<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_Ubigeo.xml */
/* Generado: 2020-08-18 04:21:29 */

/* Mantenimiento de los registros de la tabla MST_Ubigeo */
abstract class BaseMST_UbigeoDP extends MST_UbigeoBV
{
    /* Constructor ( Establece los valores desde un objeto MST_UbigeoBN ) */
    public function __construct( MST_UbigeoBN $o_MST_UbigeoBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_UbigeoBN ) )
        {
            $this->setByBN( $o_MST_UbigeoBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_UbigeoBN */
    public function setByBN( MST_UbigeoBN $o_MST_UbigeoBN )
    {
        if ( !is_null( $o_MST_UbigeoBN->getIdUbigeo() ) )
        {
            $this->setIdUbigeo( $o_MST_UbigeoBN->getIdUbigeo() );
        }
        if ( !is_null( $o_MST_UbigeoBN->getDescripcion() ) )
        {
            $this->setDescripcion( $o_MST_UbigeoBN->getDescripcion() );
        }
        if ( !is_null( $o_MST_UbigeoBN->getTipo() ) )
        {
            $this->setTipo( $o_MST_UbigeoBN->getTipo() );
        }
        if ( !is_null( $o_MST_UbigeoBN->getCodigo() ) )
        {
            $this->setCodigo( $o_MST_UbigeoBN->getCodigo() );
        }
        if ( !is_null( $o_MST_UbigeoBN->getPertenece() ) )
        {
            $this->setPertenece( $o_MST_UbigeoBN->getPertenece() );
        }
        if ( !is_null( $o_MST_UbigeoBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_UbigeoBN->getEstado() );
        }
        if ( !is_null( $o_MST_UbigeoBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_UbigeoBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_UbigeoBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_UbigeoBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_UbigeoBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_UbigeoBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_UbigeoBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_UbigeoBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_UbigeoFN = new MST_UbigeoFN();
        $o_MST_UbigeoBN = $o_MST_UbigeoFN->selectByPk( $this->getIdUbigeo() );
        if ( is_null( $o_MST_UbigeoBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_Ubigeo ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdUbigeo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUbigeo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdUbigeo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Descripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Tipo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Codigo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCodigo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPertenece() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Pertenece";
                $s_SQLQuery2 .= $s_Separator."'".$this->getPertenece()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_Ubigeo SET ";
            $s_Separator = "";
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."Descripcion = '".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipo() ) )
            {
                $s_SQLQuery .= $s_Separator."Tipo = '".$this->getTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCodigo() ) )
            {
                $s_SQLQuery .= $s_Separator."Codigo = '".$this->getCodigo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPertenece() ) )
            {
                $s_SQLQuery .= $s_Separator."Pertenece = '".$this->getPertenece()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdUbigeo = '".$this->getIdUbigeo()."';";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_Ubigeo WHERE  IdUbigeo = '".$this->getIdUbigeo()."';";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>